#pragma once

#include <windows.h>

#define APIRET_SUCCESS					0
#define APIRET_FAILURE					1
#define APIRET_VIRTFILES_DB_ERROR		2
#define APIRET_VIRTFILES_ZIP_ERROR		3
#define APIRET_NOT_FOUND				5
#define APIRET_INVALID_PARAMETER		6
#define APIRET_FILE_CREATE_ERROR		7
#define APIRET_PE_RESOURCE_ERROR		8
#define APIRET_MEMORY_ERROR				9
#define APIRET_COMMIT_ERROR				10
#define APIRET_VIRTREG_DEPLOY_ERROR		11
#define APIRET_OUTPUT_ERROR				12

typedef void *PACKAGE_HANDLE;
typedef void *SNAPSHOT_HANDLE;

typedef BOOL (_stdcall *VIRTFS_ENUM_CALLBACK)(
	LPVOID					Data,
	IN  WCHAR*				FileName,
	IN  ULONG				FileFlags,
	LARGE_INTEGER			CreationTime,
	LARGE_INTEGER			LastAccessTime,
	LARGE_INTEGER			LastWriteTime,
	LARGE_INTEGER			ChangeTime,
	LARGE_INTEGER			EndOfFile,
	ULONG					FileAttributes );

extern "C" int _stdcall
PackageOpen(
	IN  LPCWSTR				PackageExeFile,
    IN  DWORD				Reserved,
	OUT PACKAGE_HANDLE*		phPkg );

extern "C" void _stdcall
PackageClose(
	IN  PACKAGE_HANDLE		hPkg );

extern "C" int _stdcall
PackageSave(
	IN  PACKAGE_HANDLE		hPkg,
	IN  LPCWSTR				OutFileName );

extern "C" int _stdcall
PackageGetProperty(
	IN  PACKAGE_HANDLE		hPkg,
	IN  LPCWSTR				Name,
	OUT LPWSTR				Value,
	IN  DWORD				ValueLen );

extern "C" int _stdcall
PackageSetProperty(
	IN  PACKAGE_HANDLE		hPkg,
	IN  LPCWSTR				Name,
	IN  LPCWSTR				Value );

extern "C" int _stdcall
PackageSetIconFile(
	IN  PACKAGE_HANDLE		hPkg,
	IN  LPCWSTR				FileName );

extern "C" int _stdcall
PackageBuildStreaming(
	IN  PACKAGE_HANDLE		hPkg,
	IN  LPCWSTR				OutputDir );

extern "C" int _stdcall
VirtFsEnum(
	IN  PACKAGE_HANDLE		hPkg,
	IN  VIRTFS_ENUM_CALLBACK Callback,
	IN  LPVOID				Data );

extern "C" int _stdcall
VirtFsAdd(
	IN  PACKAGE_HANDLE		hPkg,
	IN  LPCWSTR				SrcFileName,
	IN  LPCWSTR				DestFileName,
	IN  BOOL				bVariablizeName );

extern "C" int _stdcall
VirtFsDelete(
	IN  PACKAGE_HANDLE		hPkg,
	IN  LPCWSTR				FileName );

extern "C" int _stdcall
VirtFsGetFileFlags(
	IN  PACKAGE_HANDLE		_hPkg,
	IN  LPCWSTR				FileName,
	OUT ULONG*				FileFlags );

extern "C" int _stdcall
VirtRegBindKey(
	IN  PACKAGE_HANDLE		hPkg,
	OUT HKEY*				hKey );
